#include "main.h"

#define THREADS 4

typedef struct arrayinfo {
    unsigned int* start;
    unsigned int length;
} arrayinfo_t;

unsigned char* colors;
const int colorLen = 0xffffff + 1;

DWORD WINAPI colorThread(void* data) {
    unsigned int i;
    arrayinfo_t* part = (arrayinfo_t*) data;
    for(i = 0; i < part->length; i++) {
        colors[*(part->start + i) & 0xffffff] = 1;
    }
    return 0;
}

int DLL_EXPORT getColorCount(unsigned int* pixel, int len) {
    int i, colorSum = 0;
    colors = (unsigned char*) calloc(colorLen, sizeof(unsigned char));
    HANDLE threads[THREADS];
    arrayinfo_t* data[THREADS];

    for(i = 0; i < THREADS; i++) {
        data[i] = (arrayinfo_t*) malloc(sizeof(arrayinfo_t));
        data[i]->start = pixel + i * (len / THREADS);
        data[i]->length = len / THREADS;
        threads[i] = CreateThread(NULL, 0, colorThread, data[i], 0, NULL);
    }
    WaitForMultipleObjects(THREADS, threads, TRUE, INFINITE);
    for(i = 0; i < THREADS; i++) {
        CloseHandle(threads[i]);
        free(data[i]);
    }
    //calculate sum
    for(i = 0; i < colorLen; i++) colorSum += colors[i];
    free(colors);
    return colorSum;
}


extern "C" DLL_EXPORT BOOL APIENTRY DllMain(HINSTANCE hinstDLL, DWORD fdwReason, LPVOID lpvReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH:
            // attach to process
            // return FALSE to fail DLL load
            break;

        case DLL_PROCESS_DETACH:
            // detach from process
            break;

        case DLL_THREAD_ATTACH:
            // attach to thread
            break;

        case DLL_THREAD_DETACH:
            // detach from thread
            break;
    }
    return TRUE; // succesful
}
